image: petrakimovdocker/ansible-gitlab-tf:latest # собираю свой образ на основе registry.gitlab.com, добавляю ansible и зеркала Yandex
variables:
  TF_ROOT: ${CI_PROJECT_DIR}/${CI_COMMIT_REF_NAME} # две ветки: develop и main
  TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/${CI_COMMIT_REF_NAME}
  TF_VAR_YANDEX_OAUTH: ${YANDEX_OAUTH}
  TF_VAR_COMMIT_TAG: ${CI_COMMIT_TAG}
  ROOT_DIR: ${CI_PROJECT_DIR}/src/service
  DOCKER_REGISTRY: docker.io
      
before_script:
  - cd ${TF_ROOT}
  
cache:
  key: tf-pipeline
  paths:
    - ${TF_ROOT}/.terraform
  
stages:
  - build
  - deploy
  - destroy

.tags_anchor: &tags_anchor # Create anchor to reuse in further code
  tags:
    - test-tag

build:  # build and push the app image to docker registry
  variables:
    TF_ROOT: ${CI_PROJECT_DIR}/main # do this job in the branch main only 
    TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/main
  stage: build
  <<: *tags_anchor
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - echo "$DOCKER_CONFIG_JSON" > /kaniko/.docker/config.json

    - /kaniko/executor --context "${ROOT_DIR}" --dockerfile "${ROOT_DIR}/Dockerfile"
      --destination "${DOCKER_REGISTRY}/petrakimovdocker/sb_advanced:${CI_COMMIT_TAG}" --cache=true --cache-repo=docker.io/petrakimovdocker/sb_advanced

    - /kaniko/executor --context "${ROOT_DIR}" --dockerfile "${ROOT_DIR}/Dockerfile"
      --destination "${DOCKER_REGISTRY}/petrakimovdocker/sb_advanced:latest" --cache=true --cache-repo=docker.io/petrakimovdocker/sb_advanced
  rules:
    - if: $CI_COMMIT_TAG =~ /^(\d+\.)?(\d+\.)?(\*|\d+)$/

apply-tags:
  variables:
    TF_ROOT: ${CI_PROJECT_DIR}/main # do this job when commit tag 
    TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/main
  stage: deploy
  <<: *tags_anchor
  environment:
    name: production
  script:
    - gitlab-terraform init
    - gitlab-terraform validate
    - gitlab-terraform plan
    - gitlab-terraform plan-json
    - echo "$ID_RSA" > ansible.key
    - chmod 400 ansible.key
    - echo "$SCRIPT" > script.sh
    - chmod 755 script.sh
    - export ANSIBLE_HOST_KEY_CHECKING=False
    - gitlab-terraform apply
  artifacts:
    name: plan
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json
  rules:
    - if: $CI_COMMIT_TAG =~ /^(\d+\.)?(\d+\.)?(\*|\d+)$/

apply-no-tags:
  variables:
    TF_VAR_COMMIT_TAG: latest
  stage: deploy
  <<: *tags_anchor
  environment:
    name: staging
  script:
    - gitlab-terraform init
    - gitlab-terraform validate
    - gitlab-terraform plan
    - gitlab-terraform plan-json
    - echo "$ID_RSA" > ansible.key
    - chmod 400 ansible.key
    - echo "$SCRIPT" > script.sh
    - chmod 755 script.sh
    - export ANSIBLE_HOST_KEY_CHECKING=False
    - gitlab-terraform apply
  artifacts:
    name: plan
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always

destroy-tags:
  variables:
    TF_ROOT: ${CI_PROJECT_DIR}/main #  do this job when commit tag
    TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/main
  stage: destroy
  <<: *tags_anchor
  script:
    - gitlab-terraform destroy
  dependencies:
    - apply-tags
  when: manual 
  rules:
    - if: $CI_COMMIT_TAG =~ /^(\d+\.)?(\d+\.)?(\*|\d+)$/

destroy-no-tags:
  variables:
    TF_VAR_COMMIT_TAG: latest
  stage: destroy
  <<: *tags_anchor
  script:
    - gitlab-terraform destroy
  dependencies:
    - apply-no-tags
  rules:
    - if: $CI_COMMIT_TAG
      when: never 
    - when: manual
